(****************************************************************************)   
(** <MKSoftware> - Software von Michael Khn fr den Unterricht *)   
(** www.mksoftware.de.vu *)
(** mail: mksoftware@bm-kuehn.de *)
(****************************************************************************)   
(* Stoppuhr.mod (Mrz 2002) *)
(* (c) by Michael Khn *)
(**                                                                          *)
(** Dieses Service-Modul darf fr Unterrichtszwecke frei verwendet werden.   *)
(**                                                                          *)
(** Fr Verbesserungsvorschlge bin ich dankbar.                             *)
(****************************************************************************)   

(** *)
(** <stoppuhr.mod>*)
(** Zeitmessung unter Pow!*)
(** Diese Stoppuhr misst in Millisekunden. Dazu muss die Datei <WinBase.sym> 
    im aktuellen Verzeichnis stehen oder im Projekt eingebunden sein!*)
(** Die Stoppuhr kann max. 2147483647 Millisekunden = 24.8 Tage messen, 
    das drfte genug sein.*)

MODULE Stoppuhr; 
IMPORT WB:=WinBase;

VAR Stoppzeit- : LONGINT; (* Millisekunden, kann nur gelesen werden! *)
    anfangszeit: LONGINT;
    zustand : INTEGER; (* 0: noch nicht gestartet, 1: luft, 2: gestoppt *)

PROCEDURE Start*;
(** Startet die Stoppuhr. Ab jetzt beginnt die Zeitmessung.*)
(** Halten Sie zeitkritische Dinge wie z. B. Bildschirmausgaben heraus!*)
(** <Achtung!> Die Stoppuhr kann nicht mit <Start> gestartet werden, 
    wenn sie bereits luft. Verwenden Sie dazu <Neustart>!*)
VAR ton: LONGINT;
BEGIN
  IF zustand # 1 THEN
    zustand := 1;
    anfangszeit:=WB.GetTickCount();
  ELSE ton:=WB.Beep(1,1);
  END;
END Start;

PROCEDURE Stopp*;
(** <Achtung!> Stopp schreibt man mit zwei p!*)
(** Stoppt die Stoppuhr, entweder zwischendurch oder endgltig.*)
(** Die (bisher) gestoppte Zeit steht in der globalen Variablen <Stoppzeit>. 
    Maeinheit sind Millisekunden. *)
VAR ton: LONGINT;
BEGIN
  IF zustand=1 THEN
    Stoppzeit:= WB.GetTickCount()-anfangszeit+ Stoppzeit;
    zustand := 2;
  ELSE ton:=WB.Beep(1,1); (* spielen die Parameter eine Rolle? *)
       Stoppzeit := 0;
       anfangszeit:=0;
       zustand := 0;
  END;
END Stopp;

PROCEDURE Weiter*;
(** Startet die Stoppuhr wieder, nachdem sie mit <Stopp> angehalten wurde.*)
VAR ton: LONGINT;
BEGIN
  CASE zustand OF
    0: (* lief noch gar nicht: Start *)
       Start;
  | 1: (* luft: mache nichts auer Piepton *)
       ton:=WB.Beep(1,1);
  | 2: (* angehalten *)
       zustand:=1; (* luft wieder *)
       anfangszeit:=WB.GetTickCount();
  ELSE (* nichts *);
  END;
END Weiter;

PROCEDURE Neustart*;
(** Startet die Stoppuhr neu, unabhngig vom aktuellen Zustand. *)
BEGIN
  zustand := 1;
  Stoppzeit:=0;
  anfangszeit:=WB.GetTickCount();
END Neustart;

BEGIN
  zustand := 0;
  Stoppzeit:=0;
  anfangszeit:=0;
END Stoppuhr.
